<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>48.50</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  </head>

<body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">User Role</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
              <span class="brand-text font-weight-light">User Role</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
                 with font-awesome or any other icon font library -->
                     
                        <li class="nav-item">
                            <a href="../index.html" class="nav-link active">
                                <i class="nav-icon fas fa-th"></i>
                                <p>
                                    User Role List
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <section class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="text-center">
                            <h2>Danh sách phân quyền người dùng</h2>
                        </div>
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">User Role List</li>
                            </ol>
                        </div>
                    </div>
                    <div class="container-fluid jumbotron">
                      <div class="row">
                        <div class="col-sm-3 text-center">
                          Role
                        </div>
                        <div class="col-sm-6">
                          <select id="select-role" class="form-control">
                            <option class="text-center">-----Chọn một role-----</option>
                          </select>
                        </div>
                        <div class="col-sm-3">
                          <button class="btn btn-success" id="btn-filter-order" style="color: aliceblue;">Lọc dữ liệu</button>
                        </div>
                      </div>
                    </div>
                </div><!-- /.container-fluid -->
            </section>

            <!-- Main content -->
            <section class="content">
              <table class="table table-bordered table-striped table-hover" id="table-user">
                <thead style="background-color: darkblue; color: aliceblue;">
                  <th>STT</th>
                  <th>User name</th>
                  <th>First name</th>
                  <th>Last name</th>
                  <th>Email</th>
                  <th>Age</th>
                  <th>Role</th>
                  <th>Action</th>
                </thead>
              </table>
            </section>
        </div>
        <footer class="main-footer">
            <div class="float-right d-none d-sm-block">
                <b>Version</b> 1.0.0
            </div>
            <strong>Copyright &copy; 2023 Devcamp.</strong> All rights
            reserved.
        </footer>

    </div>

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <!-- AdminLTE for demo purposes -->
    <!-- <script src="dist/js/demo.js"></script> -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


    <script>
  
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // Mảng gUserObjects là mảng chứa dữ liệu users
      var gUserObjects = [
            {
              id: 2,
              username: "quannv",
              firstname: "Ngo Van",
              lastname: "Quan",
              age: 18,
              email: "quan@gmail.com",
              roleId: 5
            },
            {
              id: 3,
              username: "longdh",
              firstname: "Do Hoang",
              lastname: "Long",
              age: 19,
              email: "long@gmail.com",
              roleId: 8
            },
            {
              id: 4,
              username: "hiendt",
              firstname: "Do Thi",
              lastname: "Hien",
              age: 29,
              email: "hien@gmail.com",
              roleId: 11
            },
            {
              id: 6,
              username: "lanht",
              firstname: "Ho Thi",
              lastname: "Lan",
              age: 27,
              email: "lan@gmail.com",
              roleId: 13
            }
      ];
      // Mảng gRoleObjects là mảng chứa dữ liệu các roles
      var gRoleObjects = [
            {
              roleId: 5,
              roleName: "Admin" 
            },
            {
              roleId: 8,
              roleName: "Manager" 
            },
            {
              roleId: 11,
              roleName: "Teacher" 
            },
            {
              roleId: 13,
              roleName: "Staff" 
            }
      ];
      
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      var gStt = 1;
    
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
      function onPageLoading(){
        hienDuLieuLenBang (gUserObjects);
        for (var vIndex = 0; vIndex <gRoleObjects.length; vIndex++){
            $("#select-role").append('<option value = "' + gRoleObjects[vIndex].roleId+ '">' + gRoleObjects[vIndex].roleName + '</option>');
        }
      }
    
      // Hàm xử lý sự kiện khi bấm nút btn-filter-order
      $("#btn-filter-order").on("click", function(){
        var vFilteredRole = gUserObjects.filter(filterRoleObject);
        reloadTable (vFilteredRole);
        //hienDuLieuLenBang (vFilteredOrder);
      });
    
      $("#table-user").on("click", "#dice", function () {
          onBtnDiceUserClick(this);
      });
      
      function onBtnDiceUserClick(paramBtnDice){
        const vDETAIL_FORM_URL = "diceHistory.html";
        var vUrlOpenSiter = vDETAIL_FORM_URL + 
        "?user_name=" + paramBtnDice.username +
        "&first_name=" + paramBtnDice.firstname +
        "&last_name=" + paramBtnDice.lastname;
        window.location.href=vUrlOpenSiter;
      }
      
    
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function hienDuLieuLenBang (paramUserArray){
        var vTable = $("#table-user").DataTable(
          {
            data: paramUserArray,
            columns: [
              {data: "id"},
              {data: "username"},
              {data: "firstname"},
              {data: "lastname"},
              {data: "email"},
              {data: "age"},
              {data: "roleId"},
              {data: "action"}
            ],
            columnDefs: [
              {
                target: 0,
                render: function (){
                  return gStt++;
                }
              },
              {
                target: 6,
                render: function(data){
                  for(var bI = 0; bI<gRoleObjects.length; bI++){
                    if(gRoleObjects[bI].roleId === data){
                      return gRoleObjects[bI].roleName;
                    }
                  }
                  return data;
                }
              },
              {
                target: 7,
                "defaultContent": `
                  <button class="btn btn-link" id="dice" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button> 
                  <button class="btn btn-link btn-sm" id="voucher" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>
                `
              }
            ]
          }
        )
      }
      // Hàm filter dữ liệu
      function filterRoleObject(paramRoleElement){
        return paramRoleElement.roleId == $("#select-role").val();
      }
    
      function reloadTable (paramUserArray){
        var vTable = $("#table-user").DataTable().clear();
        vTable.rows.add(paramUserArray);
        vTable.draw();
      }
    </script>
</body>

</html>